#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from cmk.gui.i18n import _
from cmk.gui.plugins.wato import (
   HostRulespec,
   rulespec_registry,
)
from cmk.gui.cee.plugins.wato.agent_bakery.rulespecs.utils import RulespecGroupMonitoringAgentsAgentPlugins

from cmk.gui.valuespec import (
   CascadingDropdown,
   Age,
   Dictionary,
   TextAscii,
   Tuple,
   ListOf,
   Transform,
   FixedValue,
)

def _valuespec_agent_config_win_smart():
    return CascadingDropdown(
        title=_("Windows SMART"),
        help=_("This will deploy the agent plugin SMART for windows"),
        choices=[
            (
                "smartctlexe", 
                _("Deploy smartctl.exe"),
                FixedValue(
                    None,
                    title=_(""),
                    totext=_("The smartctl.exe will be placed under C:\\ProgramData\\checkmk\\agent\\bin\\smartctl.exe"),
                )
            ),
            (
                "no_smartctlexe",
                _("Do not deploy smartctl.exe"),
                Transform(
                    Tuple(
                        elements=[
                            FixedValue(
                                None,
                                title=_(""),
                                totext=_("Make sure the given path is accessible for the CheckMK agent. e.g: C:\\smartctl.exe."),
                            ),
                            TextAscii(
                                label=_("Path to smartctl.exe:"),
                                default_value=r"C:\ProgramData\checkmk\agent\bin\smartctl.exe",
                            )
                        ]
                    )
               ),
            ),
        ],
    )



rulespec_registry.register(
   HostRulespec(
      group=RulespecGroupMonitoringAgentsAgentPlugins,
      name="agent_config:win_smart",
      valuespec=_valuespec_agent_config_win_smart,
   ))
   
