﻿# Oguzhan Cicek - OpenSource Security GmbH - <oguzhan@os-s.de>

$json = Get-Content "C:\ProgramData\checkmk\agent\config\smartctl_path.json" | Out-String | ConvertFrom-Json
$smartctl = $json.smartctlexe
Write-Host "<<<smart>>>"

[array] $scan_result = Invoke-Expression '& "$smartctl" --scan'

for ($i=0;$i -lt $scan_result.length;$i++) {
    $disk_path = $scan_result[$i].Split(" ")[0]
    $disk_ven = "ATA"
    if ($scan_result[$i].Contains(", ")) {
        $disk_ven = ($scan_result[$i] -split ", ")[1].Split(" ")[0]
    }
    [array] $disk_info = Invoke-Expression '& "$smartctl" -a $disk_path' 
    $disk_model = ""
    $disk_serial = ""
    for ($j=0;$j -lt $disk_info.length;$j++) {
        if ($disk_info[$j].Contains("Device Model:")) {
            $disk_model = $disk_info[$j].substring("Device Model:".Length).Trim().Replace(" ","_")
        }
        if ($disk_info[$j].Contains("Serial Number:")) {
            $disk_serial = $disk_info[$j].substring("Serial Number:".Length).Trim()
        }
    } 
    $disk_name = $disk_model + "_" + $disk_serial
    if (($disk_model -eq "iSCSI_Disk") -Or ($disk_model -eq "LOGICAL_VOLUME")) {
        continue
    }
    
    if (($disk_ven -eq "AMCC") -And ($disk_ven -ne "TWAC")) {
        continue
    } elseif ($disk_ven -ne "ATA") {
        if ($disk_ven -ne "NVME") {
            $temp=""
            [array] $cmd_res = Invoke-Expression '& "$smartctl" -d scsi -i -A $disk_path' 
            for ($j=0;$j -lt $cmd_res.length;$j++) {
                if ($cmd_res[$j].Contains("Temperature_Celsius")) {
                    $line=$cmd_rest[$j].Split('(')
                    $line=$line[0].TrimEnd()
                    $temp=$line.Split(' ')[-1]
                }
            }
            if ($temp -ne "") {
                Write-Host "194 Temperature_Celsius 0x0000 000 000 000 Old_age Always - $temp (0 0 0 0)"
            }
        }
    } else {
        [array] $cmd_res = Invoke-Expression '& "$smartctl" -d ata -v 9,raw48 -A $disk_path' 
    }

    if ($disk_ven -eq "NVME") {
        [array] $cmd_res = Invoke-Expression '& "$smartctl" -d nvme -A $disk_name' 
        $disk_name = "/dev/" + $disk_name
        Write-Host $disk_name $disk_ven $disk_model
        for ($j=5;$j -lt $cmd_res.length;$j++) {
            if ($cmd_res[$j].Trim() -ne "") {
                Write-Host $cmd_res[$j]
            } 
        }
    } else {
        for ($j=0;$j -lt $cmd_res.length;$j++) {
            if (($cmd_res[$j].Contains("Always")) -And !($cmd_res[$j].Contains("Temperature")) -And !($cmd_res[$j].Contains("UDMA_CRC_Error_Count"))) {
                Write-Host $disk_name $disk_ven $disk_model $cmd_res[$j]
            }
        }
    }
}
